//-----------------------------------------------------------------
// M-Variables.h - Created Fred Foscalina
// This is the master M-Variable file
//-----------------------------------------------------------------
//
//$Modtime: 12/15/16 9:49a $
//$Revision: 43 $
//$Author: Fredf $ 

#ifndef _M_VARIABLES_H__	// don't allow multiple loads
#define _M_VARIABLES_H__

#ifdef __cplusplus
#include "Macro Strings.h"
#endif

#ifndef TRAINER
#include "I-O Assignments.h"
#endif

#define PT8		// un-comment this to define a PT8 machine

#ifdef __cplusplus
extern double SERVO_COUNTS_PER_REV_X;		
extern double SERVO_COUNTS_PER_REV_Y;		
extern double SERVO_COUNTS_PER_REV_Z;		
extern double SERVO_COUNTS_PER_REV_A;		
extern double SERVO_COUNTS_PER_REV_SPNDL;	

extern double SERVO_BALLSCREW_PITCH_X;
extern double SERVO_BALLSCREW_PITCH_Y;
extern double SERVO_BALLSCREW_PITCH_Z;
extern double SERVO_BALLSCREW_PITCH_A;

extern double SERVO_PULLEY_RATIO_X;
extern double SERVO_PULLEY_RATIO_Y;
extern double SERVO_PULLEY_RATIO_Z;

#define	SERVO_COUNTS_PER_MM_X		(SERVO_COUNTS_PER_REV_X/SERVO_BALLSCREW_PITCH_X*SERVO_PULLEY_RATIO_X)
#define	SERVO_COUNTS_PER_MM_Y		(SERVO_COUNTS_PER_REV_Y/SERVO_BALLSCREW_PITCH_Y*SERVO_PULLEY_RATIO_Y)
#define	SERVO_COUNTS_PER_MM_Z		(SERVO_COUNTS_PER_REV_Z/SERVO_BALLSCREW_PITCH_Z*SERVO_PULLEY_RATIO_Z)
#define	SERVO_COUNTS_PER_DEG_A		(SERVO_COUNTS_PER_REV_A*SERVO_BALLSCREW_PITCH_A/360.0)

#define SERVO_COUNTS_PER_INCH_X		(SERVO_COUNTS_PER_MM_X*25.4)
#define SERVO_COUNTS_PER_INCH_Y		(SERVO_COUNTS_PER_MM_Y*25.4)
#define SERVO_COUNTS_PER_INCH_Z		(SERVO_COUNTS_PER_MM_Z*25.4)

extern double SERVO_UPDATE_RATE;
#endif

// bit selectors for limit switches  and following error
// used with InfoByte - decimal numbers used because of
// compatibility with Delta Tau compiler
#define bLimitHardXPos	1			// 0x0001
#define bLimitHardXNeg	2			// 0x0002
#define bLimitHardYPos	4			// 0x0004
#define bLimitHardYNeg	8			// 0x0008
#define bLimitHardZPos	16			// 0x0010
#define bLimitHardZNeg	32			// 0x0020
#define bLimitHard4Pos	64			// 0x0040
#define bLimitHard4Neg	128			// 0x0080

#define bLimitHardAll	255			// 0x00FF

#define bLimitSoftXPos	256			// 0x0100
#define bLimitSoftXNeg	512			// 0x0200
#define bLimitSoftYPos	1024		// 0x0400
#define bLimitSoftYNeg	2048		// 0x0800
#define bLimitSoftZPos	4096		// 0x1000
#define bLimitSoftZNeg	8192		// 0x2000
#define bLimitSoft4Pos	16384		// 0x4000
#define bLimitSoft4Neg	32768		// 0x8000

#define bLimitSoftAll	65280		// 0xFF00

#define bLimitAllX		771			// 0x0303
#define bLimitAllY		3084		// 0x0C0C
#define bLimitAllZ		12336		// 0x3030
#define bLimitAll4		49344		// 0xC0C0

#define bLimitMaskX		64764		// 0xFCFC 
#define bLimitMaskY		62451		// 0xF3F3
#define bLimitMaskZ		53199		// 0xCFCF
#define bLimitMask4		161919		// 0x3F3F

// index pulse use bits
#define bIndexUseX		1			// 0x0001
#define bIndexUseY		2			// 0x0002
#define bIndexUseZ		4			// 0x0004
#define bIndexUseA		8			// 0x0008
#define bIndexUseAll	15			// 0x000F

// index pulse error bits
#define bIndexErrorX	16			// 0x0010
#define bIndexErrorY	32			// 0x0020
#define bIndexErrorZ	64			// 0x0040
#define bIndexErrorA	128			// 0x0080

// all following error bit selectors
#define bFollowErrorX	1			// 0x0001
#define bFollowErrorY	2			// 0x0002
#define bFollowErrorZ	4			// 0x0004
#define bFollowError4	8			// 0x0008

// all fault bit selectors
#define bBothATCInputs			1			// 0x0001	mabort message
#define bBothClampInputs		2			// 0x0002   mabort message
#define bOverloadCoolant		4			// 0x0004	mabort message
#define bOverloadWash			8			// 0x0008   flashing message
#define bLowLubeLevel			16			// 0x0010	flashing and mabort message reverse logic
#define bLowLubePressure		32			// 0x0020	mabort message
#define bLowAirPressure			64			// 0x0040	flashing message
#define bFaultSpindle			128			// 0x0080	mabort message
#define bFaultSpindleTemp		256			// 0x0100	mabort message reverse logic
#define bFaultServo1			512			// 0x0200	mabort message
#define bFaultServo2			1024		// 0x0400	mabort message
#define bFaultServo3			2048		// 0x0800	mabort message
#define bFaultServo4			4096		// 0x1000	mabort message

#define b24VDCPower				8192		// 0x2000	mabort message
#define bAirOnResetATC			16384		// 0x4000	notify master to reset

#define bFaultMotorsDisabled	32768		// 0x8000	mask
#define bMaskNoMotorFault		511			// 0x01FF	mask
#define bMaskOnlyMotorFault		3584		// 0x0E00	mask

#define bFlashMsgFaults			123
#define bMAbortFaults			49031
#define bNoFaults				0			// because of reverse logic - this is needed

#define bDoorUnlocked			0
#define bDoorUserLocked			1
#define bDoorUnlockDisable		2

// capture control - use with I7mn2
#define bImmedCapture		0
#define bIndexHigh			1
#define bFlagHigh			2
#define bIndexHighFlagHigh	3
#define bIndexLow			5
#define bIndexLowFlagHigh	7
#define bFlagLow			10
#define bIndexHighFlagLow	11
#define bIndexLowFlagLow	15

// capture flag select control - use with I7mn3
#define bUseHomeFlag 0
#define bUsePosLimit 1
#define bUseNegLimit 2
#define bUseUserFlag 3

// binary rotary buffer bit selectors
#define bBinRotBufError			32768
#define bBinRotBufFull			16384
#define bBinRotBufErrorCode		255

// motor status bit selectors
#define bMotorHomeSearchBit		1024
#define bMotorDesiredVelZeroBit	8192
#define bMotorOpenLoopBit		262144
#define bMotorAmpEnabledBit		524288

// 4th axis types
#define bAAxisTypeNone		0
#define bAAxisTypeGS		2
#define bAAxisTypeSWI		3

// homing axis flags
#define bHomeXAxis			1
#define bHomeYAxis			2
#define bHomeZAxis			4
#define bHome4Axis			8
#define bHomeSpindle		16
#define bHomeHandwheel		32
#define bHomeATC			64
#define bHomeAll			128
#define bHomeCompleted		256

#define bAuxOff				0
#define bAuxManualOn		1
#define bAuxCommanded		2 

#define bAuxAutoOn			2
#define bAuxOn				1

// error log reporting
#define bATCTimingInfo		1
#define bATCTimingInfoStop	2
#define bATCDirectionCW		2
#define bATCDirectionCCW	3

// coordinate system bit selectors
#define bCSContinuousMotionMode		4			// bit 2
#define bCSContinuousMotionReq		16			// bit 4
#define bCSInPosition			131072		// bit 17

// constants used in master and plc's
#define kSpindleOff		0
#define kSpindleFwd		1
#define kSpindleRev		2

#define kMaxSpindleRPM	5000

// handwheel constants
#define kHandwheelDirectionCW	1		// encoder decode control value
#define kHandwheelDirectionCCW	5		// encoder decode control value
#define	kHandwheelQuadratureOn	2		// add to above to turn 4x quad on

// constant for ATC subroutines used with ATCCompleted
//#define bMoveToolChangerIn		3
//#define bMoveToolChangerOut		4
//#define bMoveZAxisToUnclamped		7
//#define bClampTool				5
//#define bUnclampTool				6
//#define bRotateCarouselHome		10

// log data from dpram - add more selectors when needed
#define bLogRigidTapData			1
#define bLogToolChangerData			2

// combine with above to specify size
#define bLogShort					4096	// 0x1000
#define bLogLong					8192	// 0x2000
#define bLogFloat					16384	// 0x3000

//#define ABORT_ATC					1

#define bNoAbortATC					0
#define bATCHasAborted				1
#define bAbortATC					2
#define bATCIsAborting				3

#define bToolChangeCompletedOK		1

// Subroutine defines
#define bInitToolChange				11
#define bUnloadTool					12
#define bLoadTool					13
#define bFinishToolChange			14

#define bInitAndMoveCarrierFront	20
#define bGetToolFromCarrier			21
#define bPutToolInCarrier			22

#define bMoveYToLimitSwitch			23
#define bUnloadToolNew				24
#define bLoadToolNew				25

#define bPutToolInCarrierFinish		26
#define bGetToolFromCarrierFinish	27

#define bMoveToolCarrierFront		30
#define bMoveToolCarrierFrontSub	31
#define bMoveToolCarrierBack		32
#define bMoveToolCarrierToFrontRow	33
#define bMoveToolCarrierToBackRow	34

#define bUnclampTool				35
#define bClampTool					36
#define bOrientSpindle				37
#define bOrientOff					38

#define bMoveZAxisToToolChange		40
#define bMoveZAxisToUnclamped		41
#define bMoveZAxisToUnclampedSub	42
#define bMoveZAxisToClear			43

// ******************************************
// Defines used
// ******************************************
#define OVEROFF		0
#define FEEDOVER	1
#define SPINOVER	2

#define HOMING_FAILED	0
#define HOMING_SUCCESS	1
#define HOMING_RUNNING	2
#define HOMING_CONTINUE 3

#define BLEND_ENABLE	1
#define BLEND_DISABLE	0

//#define USE_SEGMENTATION_OVERRIDE 1

// ******************************************
// M-Variables Default Definitions
// ******************************************
// 
// M-Variables defined in other files
//#define I30_0			M0
//#define I30_1			M1
//#define I30_2			M2
//#define I30_3			M3
//#define I30_4			M4
//#define I30_5			M5
//#define I30_6			M6
//#define I30_7			M7
//
//#define I31_0			M8
//#define I31_1			M9
//#define I31_2			M10
//#define I31_3			M11
//#define I31_4			M12
//#define I31_5			M13
//#define I31_6			M14
//#define I31_7			M15

//
//#define O_0			M16
//#define O_1			M17
//#define O_2			M18
//#define O_3			M19
//#define O_4			M20
//#define O_5			M21
//#define O_6			M22
//#define O_7			M23
//
//#define O_8			M24
//#define O_9 			M25
//#define O_10			M26
//#define O_11			M27
//#define O_12			M28
//#define O_13			M29
//#define O_14			M30
//#define O_15			M31

//#define ContIn1		M32
//#define ContInBuf1	M33
//
////Direction control for Direct Inputs I/O 08-15
//#define ContIn2		M34
//#define ContInBuf2	M35

//#define ContIn3		M36
//#define ContInBuf3	M37
//
////Direction control for Direct Outputs I/O 08-15
//#define ContIn4		M38
//#define ContInBuf4	M39

#define DTBlockNumber					M100

// X Axis Definitions
#define Motor1EncoderPosition			M101
#define Motor1CapturedPosition			M103
#define Motor1ADC1AFeedback				M105
#define Motor1CaptureLatch				M113
#define Motor1CaptureFlag				M117
#define Motor1HomeLimitSet				M120
#define Motor1PosHardLimitSet			M121
#define Motor1NegHardLimitSet			M122
#define Motor1HomeInProgress			M129
#define Motor1PosLimitSet				M131
#define Motor1NegLimitSet				M132
#define Motor1DesVelZero				M133
#define Motor1AssignedToCS				M134
#define Motor1OffsetModeBit				M136
#define Motor1OpenLoopBit				M138
#define Motor1PositionFilterGain		M140
#define Motor1WarningFollowError		M141
#define Motor1FatalFollowError			M142
#define Motor1HomeComplete				M145
#define Motor1CommandedPosition			M161
#define Motor1ActualPosition			M162
#define Motor1PositionBias				M164
#define Motor1ActualVelocity			M166
#define Motor1PresentMasterPosition		M167
#define Motor1CompensationCorrection	M169
#define Motor1VariableJogPosition		M172
#define Motor1HomeCapturePosition		M173
#define Motor1AverageVelocity			M174
#define Motor1BallscrewPitch			M190
#define Motor1XAxisScaleFactor			M191
#define Motor1YAxisScaleFactor			M192
#define Motor1ZAxisScaleFactor			M193
#define Motor1DisturbanceRejection		M196
#define Motor1PositionScaleFactor		M198
#define Motor1VelocityScaleFactor		M199

// Y Axis Definitions
#define Motor2EncoderPosition			M201
#define Motor2CapturedPosition			M203
#define Motor2ADC2AFeedback				M205
#define Motor2CaptureLatch				M213
#define Motor2CaptureFlag				M217
#define Motor2HomeLimitSet				M220
#define Motor2PosHardLimitSet			M221
#define Motor2NegHardLimitSet			M222
#define Motor2HomeInProgress			M229
#define Motor2PosLimitSet				M231
#define Motor2NegLimitSet				M232
#define Motor2DesVelZero				M233
#define Motor2AssignedToCS				M234
#define Motor2OffsetModeBit				M236
#define Motor2OpenLoopBit				M238
#define Motor2PositionFilterGain		M240
#define Motor2WarningFollowError		M241
#define Motor2FatalFollowError			M242
#define Motor2HomeComplete				M245
#define Motor2CommandedPosition			M261
#define Motor2ActualPosition			M262
#define Motor2PositionBias				M264
#define Motor2ActualVelocity			M266
#define Motor2PresentMasterPosition		M267
#define Motor2CompensationCorrection	M269
#define Motor2VariableJogPosition		M272
#define Motor2HomeCapturePosition		M273
#define Motor2AverageVelocity			M274
#define Motor2BallscrewPitch			M290
#define Motor2XAxisScaleFactor			M291
#define Motor2YAxisScaleFactor			M292 
#define Motor2ZAxisScaleFactor			M293
#define Motor2DisturbanceRejection		M296
#define Motor2PositionScaleFactor		M298
#define Motor2VelocityScaleFactor		M299

// Z Axis Definitions
#define Motor3EncoderPosition			M301
#define Motor3CapturedPosition			M303
#define Motor3ADC3AFeedback				M305
#define Motor3CaptureLatch				M313
#define Motor3CaptureFlag				M317
#define Motor3HomeLimitSet				M320
#define Motor3PosHardLimitSet			M321 
#define Motor3NegHardLimitSet			M322
#define Motor3HomeInProgress			M329
#define Motor3PosLimitSet				M331
#define Motor3NegLimitSet				M332
#define Motor3AssignedToCS				M334
#define Motor3OffsetModeBit				M336
#define Motor3DesVelZero				M333
#define Motor3OpenLoopBit				M338
#define Motor3PositionFilterGain		M340
#define Motor3WarningFollowError		M341
#define Motor3FatalFollowError			M342
#define Motor3HomeComplete				M345
#define Motor3CommandedPosition			M361
#define Motor3ActualPosition			M362
#define Motor3PositionBias				M364
#define Motor3ActualVelocity			M366
#define Motor3PresentMasterPosition		M367
#define Motor3CompensationCorrection	M369
#define Motor3VariableJogPosition		M372
#define Motor3HomeCapturePosition		M373
#define Motor3AverageVelocity			M374
#define Motor3BallscrewPitch			M390
#define Motor3XAxisScaleFactor			M391
#define Motor3YAxisScaleFactor			M392
#define Motor3ZAxisScaleFactor			M393
#define Motor3DisturbanceRejection		M396
#define Motor3PositionScaleFactor		M398
#define Motor3VelocityScaleFactor		M399

// 4th Axis Definitions
#define Motor4EncoderPosition			M401
#define Motor4CapturedPosition			M403
#define Motor4ADC4AFeedback				M405
#define Motor4CaptureLatch				M413
#define Motor4CaptureFlag				M417
#define Motor4PosHardLimitSet			M421 
#define Motor4NegHardLimitSet			M422
#define Motor4PosLimitSet				M431
#define Motor4NegLimitSet				M432
#define Motor4DesVelZero				M433
#define Motor4AssignedToCS				M434
#define Motor4OffsetModeBit				M436
#define Motor4OpenLoopBit				M438
#define Motor4PositionFilterGain		M440
#define Motor4FatalFollowError			M442
#define Motor4HomeComplete				M445
#define Motor4CommandedPosition			M461
#define Motor4ActualPosition			M462
#define Motor4PositionBias				M464
#define Motor4ActualVelocity			M466
#define Motor4PresentMasterPosition		M467
#define Motor4CompensationCorrection	M469
#define Motor4VariableJogPosition		M472
#define Motor4HomeCapturePosition		M473
#define Motor4AverageVelocity			M474
#define Motor4BallscrewPitch			M490
#define Motor4AAxisScaleFactor			M491
#define Motor4YAxisScaleFactor			M492
#define Motor4ZAxisScaleFactor			M493
#define Motor4PositionScaleFactor		M498
#define Motor4VelocityScaleFactor		M499

#ifdef PT8
#define SpindleEncoderPosition			M401
#define SpindleCmdValue					M402
#define SpindleCapturedPosition			M403
#define SpindleLoadValue				M405
#define SpindleEnableAmp				M414
#define SpindleCapturedFlag				M417
#define SpindleCmdSaved					M452
#define SpindleVelocity					M466
#define SpindleAvgVelocity				M474
#define SpindleMinValue					M495
#else
#define SpindleEncoderPosition			M501
#define SpindleCmdValue					M502
#define SpindleCapturedPosition			M503
#define SpindleLoadValue				M505
#define SpindleEnableAmp				M514
#define SpindleCapturedFlag				M517
#define SpindleCmdSaved					M552
#define SpindleVelocity					M566
#define SpindleAvgVelocity				M574
#define SpindleMinValue					M595
#endif
#define Motor5PositionScaleFactor		M598
#define Motor5VelocityScaleFactor		M599

#define HandwheelVelocity				M666
#define HandwheelAvgVelocity			M674
#define Motor6PositionScaleFactor		M698
#define Motor6VelocityScaleFactor		M699

// Motor 9 Definitions
#define Motor9OffsetModeBit				M936
#define Motor9CommandedPosition			M961
#define Motor9ActualPosition			M962
#define Motor9PositionBias				M964
#define Motor9PresentMasterPosition		M967
#define Motor9CompensationCorrection	M969
#define Motor9XAxisScaleFactor			M991
#define Motor9PositionScaleFactor		M998
#define Motor9VelocityScaleFactor		M999

#define Motor5AssignedToCS				M534
#define Motor6AssignedToCS				M634
#define Motor7AssignedToCS				M734
#define Motor8AssignedToCS				M834
#define Motor9AssignedToCS				M934

// velocity converters
// #define mm2cms  *(Motor1XAxisScaleFactor/60000.0)		// mm per minute -> counts per msec squared
// #define ipm2cms *(Motor1XAxisScaleFactor/60000.0*25.4)	// inches per minute -> counts per msec squared
// #define cms2mm	/(Motor1XAxisScaleFactor/60000.0)		// counts per msec squared -> mm per minute
// #define cms2ipm	/(Motor1XAxisScaleFactor/60000.0*25.4)		// counts per msec squared -> inches per minute

// ******************************************
// Dual-Ported Ram M-Variables
// ******************************************
// Common Ram Assignments

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $60000-$60019 Control Panel Functions (not used)		- PC offset 0 - 102
// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
#define dprSyncUp					M4000	//							PC offset 0
#define dprThru						M4001	//							PC offset 2
#define dprCommandPresent			M4002	//							PC offset 4
#define dprProceed					M4003	//							PC offset 6
#define dprStopContinue				M4004	//							PC offset 8
#define dprDROMode					M4005	//							PC offset 10
#define dprRunMode					M4006	//							PC offset 12
#define dprTrakingMode				M4007	//							PC offset 14
#define dprEStop					M4008	//							PC offset 16
#define dprATCCounter				M4009	// Current Tool Position	PC offset 18
#define dprATCGoTo					M4010	// Change to this tool		PC offset 20
#define dprATCGoToRunning			M4011	// Are we running			PC offset 22
#define dprJogMode					M4012	// Index counter			PC offset 24
#define dprAxisToHome				M4013	// which axis to home		PC offset 26
#define dprToolNumInSpindle			M4014	// which tool number is in	PC offset 28
#define dprSpindleOriented			M4015	// are we oriented			PC offset 30
#define dprHomingCompleted			M4016	// Are we homed				PC offset 32
#define dprIsUSAMachine				M4017	// USA or XYZ machine		PC offset 34
#define dprATCCompleted				M4018	// Are we done with the TC 	PC offset 36
#define dprTimeBasePercentage		M4019	// % command amount			PC offset 38

#define dprEndOfRunMode				M4020	// Spindle speed changed	PC offset 40
#define dprErrorStatus				M4021	// Error reporting bits		PC offset 42
#define dprLubePumpInit				M4022	// init the lube pump stuff PC offset 44
#define dprLubePumpOnTime			M4023	// lube pump on time		PC offset 46
#define dprLubePumpMotionTimer		M4024	// motion time for pump		PC offset 48
#define dprLubePumpTimeOfMotion		M4025	// accumulated motion time	PC offset 50
#define dprInMotion					M4026	// are we moving			PC offset 52
// #define dprServoIdxNow				M4027	// ServoIndexLow			PC offset 54
// #define dprSequenceNum				M4028	// ServoIndexHigh			PC offset 56
#define dprIsDoorClosed				M4029	// is the door closed 		PC offset 58
#define dprSpindleOrientOffset		M4030	// offset for orientation	PC offset 60
#define dprSpindleOrientSetPoint	M4031	// set point saved			PC offset 62
#define dprMAbortFromServo			M4032	// MAbort value				PC offset 64
#define dprFeedrate					M4033	// feedrate					PC offset 66
#define dprActualSpindleSpeed		M4034	// Spindle speed			PC offset 68
#define dprDoorUnlock				M4035	// Door unlock button		PC offset 70
#define dprYellowLight				M4036	// Yellow Light Status		PC offset 72
#define dprGreenLight				M4037	// Green Light Status		PC offset 74
#define dprPumpMode					M4038	// pump mode to check		PC offset 76
#define dprAirMode					M4039	// air mode to check		PC offset 78

#define dprSpindleDirection			M4040	// 0=Off 1=FWD 2=REV		PC offset 80
#define dprSpindleOverride			M4041	// Override Percentage		PC offset 82
#define dprSpindleOff				M4042	// Spindle off flag			PC offset 84
#define dprKeyPressed				M4043	// was the key pressed		PC offset 86
#define dprKeyReleased				M4044	// was the key released		PC offset 88
#define dprKeyCode					M4045	// actual key code			PC offset 90
#define dprKeyHandled				M4046	// did master handle it		PC offset 92
#define dprDebugMode				M4047	// debug mode for TC		PC offset 94
#define dprOverrideMode				M4048	// override mode			PC offset 96
#define dprGo						M4049	// Go status				PC offset 98
#define dprStop						M4050	// Stop status				PC offset 100
#define dprClampButtonCounts		M4051	//							PC offset 102

//																		Last PC offset 102
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $60000-$60019 Control Panel Functions (not used)		- PC offset 0 - 102
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $6001A-$6019C Motor Data Reporting Buffer		- PC offset 104 - 1650
// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
#define dprMotorReportingOn			M4100	//							PC offset 112
// motor 1 - X axis
#define dprMotor1FollowError		M4111	//							PC offset 116
#define dprMotor1ServoStatus		M4112	//							PC offset 128
#define dprMotor1GeneralStatus		M4113	//							PC offset 132
#define dprMotor1FilteredVelocity	M4114	//							PC offset 144
#define dprMotor1NetActualPos		M4115	//							PC offset 156
#define dprMotor1NetActualPos2		M4116	//							PC offset 160

// motor 2 - Y axis
#define dprMotor2FollowError		M4121	//							PC offset 164
#define dprMotor2ServoStatus		M4122	//							PC offset 176
#define dprMotor2GeneralStatus		M4123	//							PC offset 180
#define dprMotor2FilteredVelocity	M4124	//							PC offset 192
#define dprMotor2NetActualPos		M4125	//							PC offset 204
#define dprMotor2NetActualPos2		M4126	//							PC offset 208

// motor 3 - Z axis
#define dprMotor3FollowError		M4131	//							PC offset 212
#define dprMotor3ServoStatus		M4132	//							PC offset 224
#define dprMotor3GeneralStatus		M4133	//							PC offset 228
#define dprMotor3FilteredVelocity	M4134	//							PC offset 240
#define dprMotor3NetActualPos		M4135	//							PC offset 252
#define dprMotor3NetActualPos2		M4136	//							PC offset 256

// motor 4 - 4th axis
#define dprMotor4FollowError		M4141	//							PC offset 260
#define dprMotor4ServoStatus		M4142	//							PC offset 272
#define dprMotor4GeneralStatus		M4143	//							PC offset 276
#define dprMotor4FilteredVelocity	M4144	//							PC offset 288
#define dprMotor4NetActualPos		M4145	//							PC offset 300
#define dprMotor4NetActualPos2		M4146	//							PC offset 304

// motor 5 - spindle
#define dprMotor5ServoStatus		M4151	//							PC offset 320
#define dprMotor5GeneralStatus		M4152	//							PC offset 324
#define dprMotor5FilteredVelocity	M4154	//							PC offset 336
#define dprMotor5NetActualPos		M4155	//							PC offset 348
#define dprMotor5NetActualPos2		M4156	//							PC offset 352

// motor 6 - handwheel
#define dprMotor6ServoStatus		M4161	//							PC offset 368
#define dprMotor6GeneralStatus		M4162	//							PC offset 372
#define dprMotor6FilteredVelocity	M4164	//							PC offset 384
#define dprMotor6NetActualPos		M4165	//							PC offset 396
#define dprMotor6NetActualPos2		M4166	//							PC offset 400

// motor 9 - Traking counter
#define dprMotor9FollowError		M4191	//							PC offset 500
#define dprMotor9NetActualPos		M4194	//							PC offset 540
#define dprMotor9NetActualPos2		M4195	//							PC offset 544
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $6001A-$6019C Motor Data Reporting Buffer		- PC offset 104 - 1650
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $6019D-$603A6 Background Data Reporting Buffer	- PC offset 1652 - 3738
// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
#define dprBGReportingOn			M4249	//		bit 0-4				PC offset 1652
#define dprCSHostReading			M4250	//							PC offset 1654
#define dprTickCount				M4251	//							PC offset 1656
#define dprCSDataAvailable			M4252	//							PC offset 1658
#define dprGlobalStatusFromY		M4253	//							PC offset 1672	
#define dprGSBinRotBufOpen			M4254	//							PC offset 1674 - bit 4
#define dprGSMotionBufOpen			M4255	//							PC offset 1674 - bit 3
#define dprGSASCIIRotBufOpen		M4256	//							PC offset 1674 - bit 2
#define dprGSPLCBufOpen				M4257	//							PC offset 1674 - bit 1
#define dprGlobalStatusFromX		M4258	//							PC offset 1676
#define dprGSRTIReEntryError		M4259	//							PC offset 1678 - bit 5
#define dprCSFeedrate				M4260	//							PC offset 1692
#define dprCSTimebase				M4261	//							PC offset 1700
#define dprCSStatusY				M4262	//							PC offset 1708
#define dprCSRadiusError			M4263	//							PC offset 1708 - bit 4
#define dprCSSyncMVarOverflow		M4264	//							PC offset 1710 - bit 4
#define dprCSStatusX				M4265	//							PC offset 1712
#define dprCSRunningProgram			M4266	//							PC offset 1712
#define dprCSContinuousMotionMode	M4267	//							PC offset 1712
#define dprCSContinuousMotionReq	M4268	//							PC offset 1712
#define dprCSProgramStatus			M4269	//							PC offset 1788
#define dprCSRotaryBufferFull		M4270	//							PC offset 1790
#define dprCSRemainingProgramLines	M4271	//							PC offset 1792
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $6019D-$603A6 Background Data Reporting Buffer	- PC offset 1652 - 3738
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $603A7 DPRAM ASCII Command buffer				- PC offset 3740 - 3902
// $603D0 DPRAM ASCII Response buffer				- PC offset 3904 - 4162
// $60411 Background Variable Read Buffer Control	- PC offset 4164 - 4170
// $60413 Background Variable Write Buffer Control	- PC offset 4172 - 4174
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $60414-$60443 Binary Rotary Buffer Control		- PC offset 4176 - 4364
// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
#define dprBinRotBufStatus			M4274	//							PC offset 4176
#define dprBinRotBufCSNumEnable		M4275	//							PC offset 4178
#define dprBinRotBufHostIndex		M4276	//							PC offset 4180
#define dprBinRotBufPMACIndex		M4277	//							PC offset 4182
#define dprBinRotBufSize			M4278	//							PC offset 4184
#define dprBinRotBufAddrOffset		M4279	//							PC offset 4186
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $60414-$60443 Binary Rotary Buffer Control		- PC offset 4176 - 4364
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $6044F DPRAM Data Gathering Buffer Control		- PC offset 4412 - 4414
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 5118
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#define dprVersionMaster			M4280	//							PC offset 4416
#define dprIOPLCVersion				M4281	//							PC offset 4418
#define dprEHWPLCVersion			M4282	//							PC offset 4420
#define dprHomingPLCVersion			M4283	//							PC offset 4422
#define dprOverridePLCVersion		M4284	//							PC offset 4424
#define dprRunPanelPLCVersion		M4285	//							PC offset 4426
#define dprMaintenanceVersion		M4286	//							PC offset 4428
#define dprToolCarrierVersion		M4287	//							PC offset 4430
#define dprInitPLCVersion			M4288	//							PC offset 4432
#define dprRigidTapVersion			M4289	//							PC offset 4434
#define dprHandwheelVersion			M4290	//							PC offset 4436
#define dprTrakingVersion			M4291	//							PC offset 4438

#define dprXFeedrate				M4293	//							PC offset 4440
#define dprYFeedrate				M4294	//							PC offset 4442
#define dprZFeedrate				M4295	//							PC offset 4444
// used below						M5407	//							PC offset 4446
#define dprBufferIsOpen				M4298	//							PC offset 4448
#define dprLubeLevelLow				M4299	//							PC offset 4450
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 5118
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// binary rotary transfer buffer will start at		- PC offset 5120 - 16,378
// DP:$60500
// offset is 176/0xB0 from DP:$60450
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// ******************************************
// Miscellaneous Ram M-Variables
// ******************************************
#define desiredVelocityZeroAxis1	M4301
#define desiredVelocityZeroAxis2	M4302
#define desiredVelocityZeroAxis3	M4303
#define desiredVelocityZeroAxis4	M4304
#define desiredVelocityZeroAxis5	M4305

#define inPositionAxis1				M4306
#define inPositionAxis2				M4307
#define inPositionAxis3				M4308
#define inPositionAxis4				M4309
#define inPositionAxis5				M4310

#define Axis1VariableJogPosition	M4311
#define Axis2VariableJogPosition	M4312
#define Axis3VariableJogPosition	M4313
#define Axis4VariableJogPosition	M4314
#define Axis5VariableJogPosition	M4315

#define ZAxisToolChangePosition		M4316
#define ZAxisUnclampedPosition		M4317

#define CSTimebaseControlAddress	M4318
#define CSRotaryBufferFull			M4319

//#define unused	M4320
//#define unused	M4321

#define OverridePLCWasOn			M4322
#define PrevTimeBasePercentage		M4323

#define CSInPositionBit				M4324

#define GlobalStatusFromY			M4325
#define GlobalStatusFromX			M4326

#define CSStatusFromX				M4327
#define CSStatusFromY				M4328

// unused
#define CSContinuousMotion			M4329

#ifdef PT8
#define Motor1HomeSwitch			M4331
#define Motor2HomeSwitch			M4332
#define Motor3HomeSwitch			M4333
#endif

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 5118
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// Rigid Tapping M-Variables
#define RigidTapZRapid				M4351	// Starting position
#define RigidTapDepth				M4352	// Total depth to tap
#define RigidTapStopPosition		M4353	// Stop position to give spindle enough time to stop - unscaled
#define RigidTapPitch				M4354	// Pitch of desired thread
#define RigidTapFeedrate			M4355	// Z Axis feedrate - adjusted by timebase
#define RigidTapRPM					M4356	// Spindle RPM
#define RigidTapRTIF				M4357	// Real Time Input Frequency
#define RigidTapTBSF				M4358	// Time Base Scale Factor
#define RigidTapStoppingTurns		M4359	//
#define RigidTapStopCounts			M4360
#define RigidTapTopCounts			M4361
#define RigidTapZBegin				M4362	// usually the top of the hole
#define RigidTapZStart				M4363	// an amount above Z begin to allow for acceleration

// timer variable store as 36 bit signed int
#define dprTotalMachineTime			M4370
#define dprTotalSpindleTime			M4371

// limit switches
#define dprSoftLimitXPos			M4380	//							PC offset 5000
#define dprSoftLimitXNeg			M4381	//							PC offset 5002
#define dprSoftLimitYPos			M4382	//							PC offset 5004
#define dprSoftLimitYNeg			M4383	//							PC offset 5006
#define dprSoftLimitZPos			M4384	//							PC offset 5008
#define dprSoftLimitZNeg			M4385	//							PC offset 5010
#define dprSoftLimit4Pos			M4386	//							PC offset 5012
#define dprSoftLimit4Neg			M4387	//							PC offset 5014

#define dprHardLimitXPos			M4390	//							PC offset 5016
#define dprHardLimitXNeg			M4391	//							PC offset 5018
#define dprHardLimitYPos			M4392	//							PC offset 5020
#define dprHardLimitYNeg			M4393	//							PC offset 5022
#define dprHardLimitZPos			M4394	//							PC offset 5024
#define dprHardLimitZNeg			M4395	//							PC offset 5026
#define dprHardLimit4Pos			M4396	//							PC offset 5028
#define dprHardLimit4Neg			M4397	//							PC offset 5030

#define dprMaxFollowErrorX			M4398	//							PC offset 5032
#define dprMaxFollowErrorY			M4399	//							PC offset 5034
#define dprMaxFollowErrorZ			M4400	//							PC offset 5036
#define dprMaxFollowError4			M4401	//							PC offset 5038

#define dprAllLimits				M4402	//							PC offset 5040
#define dprAllFollowError			M4403	//							PC offset 5042
#define dprAllFaults				M4404	//							PC offset 5044

#define dprMaxFeedrate				M4405	//							PC offset 5046
#define dprGoButtonAllowed			M4406	//							PC offset 5048
#define dprServoAbortFromMaster		M4407	//							PC offset 5050
#define dprEnableOverridePLC		M4408	//							PC offset 5052
#define dprTrakingSpeed				M4409	//							PC offset 5054

#define dprSpindleRevsTest			M4410	// Spindle Stopping Test	PC offset 5056
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 5118
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// m-variable for jogging and homing
#define ActualPosM					M4501
#define CommandedPositionM			M4502
#define PosBiasM					M4503
#define JogVarPositionM				M4504
#define DesiredVelZeroM				M4505
#define InPositionM					M4506
#define PosLimitM					M4507
#define NegLimitM					M4508
#define JogVarDistanceM				M4509
#define ActualPosition				M4510
#define CommandedPosition			M4511
#define PosScale					M4512

///////////////////////////////////////////
// X Axis jog variables
///////////////////////////////////////////
#define ActualPosXM      			M4513
#define PosBiasXM					M4514
#define JogVarDistanceXM			M4515
#define DesiredVelZeroXM			M4516
#define InPositionXM				M4517
#define PosLimitXM					M4518
#define NegLimitXM					M4519
///////////////////////////////////////////
// X Axis variables for Home
///////////////////////////////////////////
#define HomeCompleteXM				M4520
#define PulsePerUnitXM				M4521

///////////////////////////////////////////
// Y Axis jog variables
///////////////////////////////////////////
#define ActualPosYM      			M4522
#define PosBiasYM					M4523
#define JogVarDistanceYM			M4524
#define DesiredVelZeroYM			M4525
#define InPositionYM				M4526
#define PosLimitYM					M4527
#define NegLimitYM					M4528
///////////////////////////////////////////
// Y Axis variables for Home
///////////////////////////////////////////
#define HomeCompleteYM				M4529
#define PulsePerUnitYM				M4530

///////////////////////////////////////////
// Z Axis jog variables
///////////////////////////////////////////
#define ActualPosZM      			M4531
#define PosBiasZM					M4532
#define JogVarDistanceZM			M4533
#define DesiredVelZeroZM			M4534
#define InPositionZM				M4535
#define PosLimitZM					M4536
#define NegLimitZM					M4537
///////////////////////////////////////////
// Z Axis variables for Home
///////////////////////////////////////////
#define HomeCompleteZM				M4538
#define PulsePerUnitZM				M4539

///////////////////////////////////////////
// 4th Axis jog variables
///////////////////////////////////////////
#define ActualPos4M      			M4541
#define PosBias4M					M4542
#define JogVarDistance4M			M4543
#define DesiredVelZero4M			M4544
#define InPosition4M				M4545
#define PosLimit4M					M4546
#define NegLimit4M					M4547
///////////////////////////////////////////
// Z Axis variables for Home
///////////////////////////////////////////
#define HomeComplete4M				M4548
#define PulsePerUnit4M				M4549

// pointer variables to other M-variables
#define ActualPosP					M4571
#define CommandedPosP				M4572
#define PosBiasP					M4573
#define JogVarPositionP				M4574
#define DesiredVelZeroP				M4575
#define InPositionP					M4576
#define PosLimitP					M4577
#define NegLimitP					M4578
#define JogVarDistanceP				M4579

#define SpindleCurrentBaseM			M4580
#define SpindleCurrentBaseP			M4581

#define ActualPosSpindleM			M4582

#define clampPLCDisable				M4590

#define ehwCountM					M4601
#define ehwPrevCountM				M4602
#define ehwDirectionChangedBit		M4603
#define ehwTimeBetweenClicks		M4604
#define ehwVelocity					M666	// suggested m-variable description

// Timer stuff
#define TickCount					M4700
#define TotalMachineTicks			M4701
#define TotalSpindleTicks			M4702
#define Timer03						M4703	// currently not used
#define Timer04						M4704	// currently not used	
#define Timer05						M4705	// currently not used	
#define Timer06						M4706	// currently not used	
#define Timer07						M4707	// currently not used
#define Timer08						M4708	// currently not used
#define TickCountResult				M4710

#define TrakTimeBase				M4711
#define ManualTimeBase				M4712
#define CmdTimeBase					M4713
#define CS1SlewedTimeBase			M4714

#define EndOfMemory					M4720

#define ElapsedTimeCounter			M5017	// 1/1024 seconds since startup
#define CurrentMachineTicks			M5018	// machine timer start when not moving
#define CurrentSpindleTicks			M5019	// spindle timer start when not moving

#define CSWarningFollowingErrorBit	M5188
#define CSFatalFollowingErrorBit	M5189

#define BufferOpenBit				M5191
#define ContinuousMotionRequestBit	M5192

#define TimeBasePercentageCmd		M5197	// suggested m-variable description
#define TimeBasePercentage			M5198	// suggested m-variable description
#define TimeBasePosition			M5199

//#define 			M5200
//#define			M5201

#define TimeBaseTrigger				M5203

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 5118
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// continuing dpr definitions
#define dprFeedrateRunning			M5407	//							PC offset 4446

//	Already define above			M4298	//							PC offset 4448
//	Already define above			M4299	//							PC offset 4450

#define dprCapturedAngleX			M5410	//							PC offset 4452
#define dprCapturedAngleY			M5411	//							PC offset 4454
#define dprCapturedAngleZ			M5412	//							PC offset 4456

#define dprTimeBasePercentageDRO	M5413	//							PC offset 4458
#define dprStatusPLCVersion			M5414	//							PC offset 4460

#define dprNoSpindleAllowed			M5415	//							PC offset 4462
#define dprDoorLockState			M5416	//							PC offset 4464

#define dprSpindleWasOnFwd			M5417	//							PC offset 4466
#define dprSpindleWasOnRev			M5418	//							PC offset 4468

#define dprToolCarrierIsFront		M5419	//							PC offset 4470

#define dprSpindleCurrent			M5420	//							PC offset 4472
#define dprSpindleM502Value			M5421	//							PC offset 4474
#define dprUseSoftLimits			M5422	//							PC offset 4476
#define dprRestartRotaryBuffer		M5423	//							PC offset 4478
#define dprBinRotBufBusy			M5424	//							PC offset 4480

#define dprCapturedPositionX		M5425	//							PC offset 4482
#define dprCapturedPositionY		M5426	//							PC offset 4484
#define dprCapturedPositionZ		M5427	//							PC offset 4486

#define dprAbortStatus				M5428	//							PC offset 4488
#define dprCriticalPLCVersion		M5429	//							PC offset 4490
#define dprAsciiStrToRotRetVal		M5430	//							PC offset 4492

#define dprWashCoolant				M5431	//							PC offset 4494
#define dprConveyorCW				M5432	//							PC offset 4496
#define dprConveyorCCW				M5433	//							PC offset 4498

#define dprLubePressureError		M5434	//							PC offset 4500
#define dprLubePressureLowCount		M5435	//							PC offset 4502

#define dprDesiredVelocityZero		M5436	//							PC offset 4504
#define dprIsDoorUnlocked			M5437	//							PC offset 4506

#define dprMotor1ActualPos			M5438	//							PC offset 4508
#define dprMotor2ActualPos			M5439	//							PC offset 4512
#define dprMotor3ActualPos			M5440	//							PC offset 4516
#define dprMotor4ActualPos			M5441	//							PC offset 4520
#define dprMotor5ActualPos			M5442	//							PC offset 4524
#define dprMotor6ActualPos			M5443	//							PC offset 4528

#define dprToolCarrierIsBack		M5444	//							PC offset 4532
#define dprAFeedrate				M5445	//							PC offset 4534

#define dprCapturedAngle4			M5446	//							PC offset 4536
#define dprCapturedPosition4		M5447	//							PC offset 4538

#define dprMotor4CutRadius			M5448	//							PC offset 4540	// this is a float
#define dprMotor4BaseHeight			M5449	//							PC offset 4544

#define dprServoIsFault				M5450	//							PC offset 4548

// unused							M5451	//							PC offset 4550

#define dprZToolOffset				M5452	//							PC offset 4552	// this is a float

#define dprSpindleM505Value			M5453	//							PC offset 4556
#define dprMotor4AutoClamp			M5454	//							PC offset 4558

#define dprHas4thAxis				M5455	//							PC offset 4560
#define dprIsResettingServos		M5456	//							PC offset 4562

#define dprBaseToolHeight			M5457	//							PC offset 4564	// this is a float

#define dprDoorClosedDebounceTime	M5458	//							PC offset 4568

// unused offset					M5459	//							PC offset 4570

#define dprPrevContinuousMotion		M5460	//							PC offset 4572

#define dprCurrentServoIdxNow		M5461	//							PC offset 4574
#define dprCurrentSequenceNum		M5462	//							PC offset 4576

#define dprATCMode					M5463	//							PC offset 4578

#define	dprATCFrontOutput			M5464	//							PC offset 4580
#define	dprATCBackOutput			M5465	//							PC offset 4582

#define dprServoIdxNow				M4027	// ServoIndexLow			PC offset 4584	// these are being redefined to use 32 bit instead of 16 bit
#define dprSequenceNum				M4028	// ServoIndexHigh			PC offset 4588	// these are being redefined to use 32 bit instead of 16 bit

#define dprGoButtonWasAllowed		M5466	// ServoIndexHigh			PC offset 4592
#define dprCSContMotionRequest		M5467	//							PC offset 4594

#define dprStartUpInProgress		M5468	//							PC offset 4596		

// M-Variables space unused
//#define 		M5469		

//Offsets unused
//unused offset		//							PC offset 4598
//unused offset		//							PC offset 4600
//unused offset		//							PC offset 4602
//unused offset		//							PC offset 4604
//unused offset		//							PC offset 4606
//unused offset		//							PC offset 4608
//unused offset		//							PC offset 4610


#define dprMotor9ActualPos 			M5469	//							PC offset 4612	// this is a float


#define dprConveyorWasOn			M5470	//							PC offset 4616
#define dprUBufBase					M5471	//							PC offset 4618
#define dprIs4thAxisUnclamped		M5472	//							PC offset 4620

#define dprResetServoPLCVersion		M5473	//							PC offset 4622
#define dprResetFollowingError		M5474	//							PC offset 4624

#define dprToolChangeActive			M5475	//							PC offset 4626
#define dprMotor9CommandedPos		M5476	//							PC offset 4628

#define dprHandwheelEnabled			M5477	//							PC offset 4630

#define dprErrorLogUpdate			M5478	//							PC offset 4632

#define dprATCTimingOnToEdge		M5479	//							PC offset 4634
#define dprATCTimingEdgeToEdge		M5480	//							PC offset 4636
#define dprATCTimingEdgeToCmdOff	M5481	//							PC offset 4638
#define dprATCRotationDirection		M5482	//							PC offset 4640
#define dprATCRotationTime			M5483	//							PC offset 4642

#define dprIsZAxisAtToolChange		M5484	//							PC offset 4644
#define dprAAxisType				M5485	//							PC offset 4646
#define dprLogDPRamData				M5486	//							PC offset 4648

#define dprProductCode				M5487	//							PC offset 4650

// Traking configuration parameters
#define dprTrakSlewRunning			M5488	//							PC offset 4652
#define dprTrakSlewStopped			M5489	//							PC offset 4654
#define dprTrakFastAccel			M5490	//							PC offset 4656	// this is a float
#define dprTrakSlowAccel			M5491	//							PC offset 4660	// this is a float

#define dprCurrentFRAXState			M5492	//							PC offset 4664	// this is a long

#define dprCurrentMotionMode		M5493	//							PC offset 4668
#define dprPreRunMode				M5494	//							PC offset 4670

#define dprHandwheelDirection		M5495	//							PC offset 4672

#define dprFEIndexCounter			M5496	//							PC offset 4674	
#define dprFEAxis					M5497	//							PC offset 4676
#define dprFEIndexMin				M5498	//							PC offset 4678
#define dprFEIndexMax				M5499	//							PC offset 4680
#define dprFEIndexDir				M5500	//							PC offset 4682
#define dprFEAdjustment				M5501	//							PC offset 4684

#define dprServosEnabledLatch		M5502	//							PC offset 4686
#define dprServosEnabled			M5503	//							PC offset 4688
#define dprCapturedAxisFlags		M5504	//							PC offset 4690

#define dprMotor1CurrentFeedback	M5505	//							PC offset 4692
#define dprMotor2CurrentFeedback	M5506	//							PC offset 4694
#define dprMotor3CurrentFeedback	M5507	//							PC offset 4696
#define dprMotor4CurrentFeedback	M5508	//							PC offset 4698

#define dprIsOKToGather				M5509	//							PC offset 4700
#define dprRigidTapMode				M5510	//							PC offset 4702

#define dprSpindleForwardOutput		M5511	//							PC offset 4704
#define dprSpindleReverseOutput		M5512	//							PC offset 4706		
#define dprSpindleAgreeInput		M5513	//							PC offset 4708
#define dprSpindleOrientOutput		M5514	//							PC offset 4710

#define dprWatchdogCounter			M5515	//							PC offset 4712
#define dprOKToStop					M5516	//							PC offset 4714
#define dprStopButtonPressed		M5517	//							PC offset 4716
#define dprStatThreadExecTime		M5518	//							PC offset 4718

#define dprServiceCodeMode			M5519	//							PC offset 4720

// unused PC offset					M5520	//							PC offset 4722

#define dprTotalATCCount			M5521	//							PC offset 4724	// this is a long

#define dprCopyCSVariables			M5522	//							PC offset 4728
#define dprCSContMotion				M5523	//							PC offset 4730

// next PC offset							//							PC offset 4732

// last unused PC offset					//							PC offset 4998
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 5118
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

#define IOTimerResult				M8100
#define RunPanelTimerResult			M8101
#define SpindleStartResult			M8102
#define HomingTimerResult			M8103
#define JoggingTimerResult			M8104
#define RigidTapTimerResult			M8105
#define LubePumpTimerResult			M8106
#define BeaconLightTimerResult		M8107
#define TrainerTimerResult			M8108
#define FeedHoldSlewTimerResult		M8109
#define KillMotorDelayTimerResult	M8110

// ******************************************
// Below is for Delta Tau compiler ONLY
// ******************************************
#ifndef __cplusplus
#define ServoUpdateRate	(8388608/I10)
#define msecs *ServoUpdateRate
#define secs msecs*1000

#define _delay I6511
#define ms *8388608/I10while(_delay>0)endw
/*
//Now in  PLC code simply put this line to create a delay

_delay = 1000 ms 

translates to :
I6511 = 1000*8388608/I10 while(I6511>0)endw
*/

#define ipm *(Motor1XAxisScaleFactor/60000*25.4)

#ifdef PT8
inLubeLevelFull->*
inLubeLevelFull = 1
inSpindleTemperatureOK->*
inSpindleTemperatureOK = 1
#endif

Motor1ADC1AFeedback->Y:$07800D,8,16,S		// ADC1A input value
Motor2ADC2AFeedback->Y:$078005,8,16,S		// ADC2A input value
Motor3ADC3AFeedback->Y:$07801D,8,16,S		// ADC3A input value
Motor4ADC4AFeedback->Y:$078015,8,16,S		// ADC4A input value
M505->Y:$07810D,8,16,S		// ADC5A input value
M605->Y:$078105,8,16,S		// ADC6A input value
M705->Y:$07811D,8,16,S		// ADC7A input value
M805->Y:$078115,8,16,S		// ADC8A input value

Motor1AssignedToCS->Y:$00C0,15,1
Motor2AssignedToCS->Y:$0140,15,1
Motor3AssignedToCS->Y:$01C0,15,1
Motor4AssignedToCS->Y:$0240,15,1
Motor5AssignedToCS->Y:$02C0,15,1
Motor6AssignedToCS->Y:$0340,15,1
Motor7AssignedToCS->Y:$03C0,15,1
Motor8AssignedToCS->Y:$0440,15,1
Motor9AssignedToCS->Y:$04C0,15,1

Motor1HomeInProgress->X:$B0,10
Motor2HomeInProgress->X:$130,10
Motor3HomeInProgress->X:$1B0,10

// DPRAM ADDRESSES
// $60000 Control Panel Functions (pending)			- PC offset 0 - 102
// $6001A Motor Data Reporting Buffer				- PC offset 104 - 1650
// $6019D Background Data Reporting Buffer			- PC offset 1652 - 3738
// $603A7 DPRAM ASCII Command buffer				- PC offset 3740 - 3902
// $603D0 DPRAM ASCII Response buffer				- PC offset 3904 - 4162
// $60411 Background Variable Read Buffer Control	- PC offset 4164 - 4170
// $60413 Background Variable Write Buffer Control	- PC offset 4172 - 4174
// $60414 Binary Rotary Program Buffer Control		- PC offset 4176 - 4364
// $6044F DPRAM Data Gathering Buffer Control		- PC offset 4412 - 4414
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 16,378
// $60FFF* End of Small (8k x 16) DPRAM
// $63FFF* End of Large (32k x 16) DPRAM

// *Memory register Y:$3F contains the address of the last DPRAM address,
//  plus one ($061000 or $064000)

// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $60000-$6001A Control Panel Functions (not used)		- PC offset 0 - 102
// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
dprSyncUp->Y:$60000,0,16					// SyncUp					PC offset 0
dprThru->X:$60000,0,16						// Thru						PC offset 2
dprCommandPresent->Y:$60001,0,16			// CommandPresent			PC offset 4
dprProceed->X:$60001,0,16					// Proceed					PC offset 6

dprStopContinue->Y:$60002,0,16				// StopContinue				PC offset 8
dprDROMode->X:$60002,0,16					// DRO mode					PC offset 10
dprRunMode->Y:$60003,0,16					// Run mode					PC offset 12
dprTrakingMode->X:$60003,0,16				// Traking mode				PC offset 14

dprEStop->Y:$60004,0,16						// 							PC offset 16
dprATCCounter->X:$60004,0,16				// 							PC offset 18
dprATCGoTo->Y:$60005,0,16					// 							PC offset 20
dprATCGoToRunning->X:$60005,0,16			// 							PC offset 22
dprJogMode->Y:$60006,0,16					// 							PC offset 24
dprAxisToHome->X:$60006,0,16				//							PC offset 26  x=1 y=2 z=4 tc=8 4th=16 - all = 31 
dprToolNumInSpindle->Y:$60007,0,16			// 							PC offset 28
dprSpindleOriented->X:$60007,0,16			// 							PC offset 30
dprHomingCompleted->Y:$60008,0,16			// 							PC offset 32
dprIsUSAMachine->X:$60008,0,16				// USA or XYZ machine		PC offset 34
dprATCCompleted->Y:$60009,0,16				// Are we done with TC 		PC offset 36
dprTimeBasePercentage->X:$60009,0,16		// Are we done with TC 		PC offset 38

// status registers
dprEndOfRunMode->Y:$6000A,0,16				// After M30 before Mode	PC offset 40
dprErrorStatus->X:$6000A,0,16				//							PC offset 42

dprLubePumpInit->Y:$6000B,0,16				// 							PC offset 44
dprLubePumpOnTime->X:$6000B,0,16			// 							PC offset 46
dprLubePumpMotionTimer->Y:$6000C,0,16		// 							PC offset 48
dprLubePumpTimeOfMotion->X:$6000C,0,16		//							PC offset 50
dprInMotion->Y:$6000D,0,16					// 							PC offset 52

// dprServoIdxNow->X:$6000D,0,16				// 							PC offset 54
// dprSequenceNum->Y:$6000E,0,16				// 							PC offset 56

dprIsDoorClosed->X:$6000E,0,16				//							PC offset 58
dprSpindleOrientOffset->Y:$6000F,0,16		//							PC offset 60
dprSpindleOrientSetPoint->X:$6000F,0,16		//							PC offset 62
dprMAbortFromServo->Y:$60010,0,16			//							PC offset 64

dprFeedrate->X:$60010,0,16					//							PC offset 66
dprActualSpindleSpeed->Y:$60011,0,16				// SpindleSpeed				PC offset 68

// I/O status that maps to DPRAM
dprDoorUnlock->X:$60011,0,16				//							PC offset 70
dprYellowLight->Y:$60012,0,16				//							PC offset 72
dprGreenLight->X:$60012,0,16				//							PC offset 74

dprPumpMode->Y:$60013,0,16					//							PC offset 76
dprAirMode->X:$60013,0,16					//							PC offset 78

dprSpindleDirection->Y:$60014,0,16			//							PC offset 80
dprSpindleOverride->X:$60014,0,16			//							PC offset 82
dprSpindleOff->Y:$60015,0,16				//							PC offset 84

dprKeyPressed->X:$60015,0,16				//							PC offset 86
dprKeyReleased->Y:$60016,0,16				//							PC offset 88
dprKeyCode->X:$60016,0,16					// 							PC offset 90
dprKeyHandled->Y:$60017,0,16				//							PC offset 92

dprDebugMode->X:$60017,0,16					//							PC offset 94
dprOverrideMode->Y:$60018,0,16				//							PC offset 96

dprGo->X:$60018,0,16						//							PC offset 98
dprStop->Y:$60019,0,16						//							PC offset 100
dprClampButtonCounts->X:$60019,0,16			//							PC offset 102
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $60000 Control Panel Functions (not used)		- PC offset 0 - 102
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $6001A-$6019C Motor Data Reporting Buffer		- PC offset 104 - 1650
// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
dprMotorReportingOn->Y:$6001C,0,16			//							PC offset 112

// motor 1 - X axis
dprMotor1FollowError->DP:$6001D				//							PC offset 116
dprMotor1ServoStatus->DP:$60020				//							PC offset 128
dprMotor1GeneralStatus->DP:$60021			//							PC offset 132
dprMotor1FilteredVelocity->DP:$60024		//							PC offset 144
dprMotor1NetActualPos->DP:$60027			//							PC offset 156
dprMotor1NetActualPos2->DP:$60028			//							PC offset 160

// motor 2 - Y axis
dprMotor2FollowError->DP:$60029				//							PC offset 164
dprMotor2ServoStatus->DP:$6002C				//							PC offset 176
dprMotor2GeneralStatus->DP:$6002D			//							PC offset 180
dprMotor2FilteredVelocity->DP:$60030		//							PC offset 192
dprMotor2NetActualPos->DP:$60033			//							PC offset 204
dprMotor2NetActualPos2->DP:$60034			//							PC offset 208

// motor 3 - Z axis
dprMotor3FollowError->DP:$60035				//							PC offset 212
dprMotor3ServoStatus->DP:$60038				//							PC offset 224
dprMotor3GeneralStatus->DP:$60039			//							PC offset 228
dprMotor3FilteredVelocity->DP:$6003C		//							PC offset 240
dprMotor3NetActualPos->DP:$6003F			//							PC offset 252
dprMotor3NetActualPos2->DP:$60040			//							PC offset 256

// motor 4 - 4th axis
dprMotor4FollowError->DP:$60041				//							PC offset 260
dprMotor4ServoStatus->DP:$60044				//							PC offset 272
dprMotor4GeneralStatus->DP:$60045			//							PC offset 276
dprMotor4FilteredVelocity->DP:$60048		//							PC offset 288
dprMotor4NetActualPos->DP:$6004B			//							PC offset 300
dprMotor4NetActualPos2->DP:$6004C			//							PC offset 304

// motor 5 - spindle
dprMotor5ServoStatus->DP:$60050				//							PC offset 320
dprMotor5GeneralStatus->DP:$60051			//							PC offset 324
dprMotor5FilteredVelocity->DP:$60054		//							PC offset 366
dprMotor5NetActualPos->DP:$60057			//							PC offset 348
dprMotor5NetActualPos2->DP:$60058			//							PC offset 352

// motor 6 - handwheel
dprMotor6ServoStatus->DP:$6005C				//							PC offset 368
dprMotor6GeneralStatus->DP:$6005D			//							PC offset 372
dprMotor6FilteredVelocity->DP:$60060		//							PC offset 384
dprMotor6NetActualPos->DP:$60063			//							PC offset 396
dprMotor6NetActualPos2->DP:$60064			//							PC offset 400

// motor 9 - Traking counter
dprMotor9FollowError->DP:$6007D				//							PC offset 500
dprMotor9NetActualPos->DP:$60087			//							PC offset 540
dprMotor9NetActualPos2->DP:$60088			//							PC offset 544
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $6001A Motor Data Reporting Buffer				- PC offset 104 - 1650
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $6019D Background Data Reporting Buffer			- PC offset 1652 - 3738
// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
dprBGReportingOn->Y:$6019D,0,4				//	only using bits 0-4		PC offset 1652
dprCSHostReading->X:$6019D,15,1				//							PC offset 1654
dprTickCount->Y:$6019E,0,16					//							PC offset 1656
dprCSDataAvailable->X:$6019E,15,1			//							PC offset 1658

// all global status bits from Y register - Y:$6 
dprGlobalStatusFromY->DP:$601A2				//							PC offset 1672
dprGSBinRotBufOpen->X:$601A2,4,1			//							PC offset 1674 - bit 4
dprGSMotionBufOpen->X:$601A2,3,1			//							PC offset 1674 - bit 3
dprGSASCIIRotBufOpen->X:$601A2,2,1			//							PC offset 1674 - bit 2
dprGSPLCBufOpen->X:$601A2,1,1				//							PC offset 1674 - bit 1

// all global status bits from X register - X:$6
dprGlobalStatusFromX->DP:$601A3				//							PC offset 1676
dprGSRTIReEntryError->X:$601A3,6,1			//							PC offset 1678

dprCSFeedrate->DP:$601A7					//							PC offset 1692
dprCSTimebase->DP:$601A9					//							PC offset 1700
dprCSStatusY->DP:$601AB						//							PC offset 1708
dprCSRadiusError->Y:$601AB,3,1				//							PC offset 1708 - bit 4
dprCSSyncMVarOverflow->X:$601AB,3,1			//							PC offset 1710 - bit 4
dprCSStatusX->DP:$601AC						//							PC offset 1712
dprCSRunningProgram->Y:$601AC,0,1			//							PC offset 1712
dprCSContinuousMotionMode->Y:$601AC,2,1		//							PC offset 1712
dprCSContinuousMotionReq->Y:$601AC,4,1		//							PC offset 1712
dprCSProgramStatus->DP:$601BF				//							PC offset 1788

// the following is bit 0 but on the X side of the register which is bit 16 of the address
dprCSRotaryBufferFull->X:$601BF,0,1			//							PC offset 1790
dprCSRemainingProgramLines->DP:$601C0		//							PC offset 1792
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $6019D Background Data Reporting Buffer			- PC offset 1652 - 3738
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $603A7 DPRAM ASCII Command buffer				- PC offset 3740 - 3902
// $603D0 DPRAM ASCII Response buffer				- PC offset 3904 - 4162
// $60411 Background Variable Read Buffer Control	- PC offset 4164 - 4170
// $60413 Background Variable Write Buffer Control	- PC offset 4172 - 4174
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $60414 Binary Rotary Program Buffer Control		- PC offset 4176 - 4364
// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
dprBinRotBufStatus->Y:$60414,0,16			//							PC offset 4176
dprBinRotBufCSNumEnable->X:$60414,0,16		//							PC offset 4178
dprBinRotBufHostIndex->Y:$60415,0,16		//							PC offset 4180
dprBinRotBufPMACIndex->X:$60415,0,16		//							PC offset 4182
dprBinRotBufSize->Y:$60416,0,16				//							PC offset 4184
dprBinRotBufAddrOffset->X:$60416,0,16		//							PC offset 4186
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $60414 Binary Rotary Program Buffer Control		- PC offset 4176 - 4364
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $6044F DPRAM Data Gathering Buffer Control		- PC offset 4412 - 4414
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 5118
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
dprVersionMaster->Y:$60450,0,16				//							PC offset 4416
dprIOPLCVersion->X:$60450,0,16				//							PC offset 4418
dprEHWPLCVersion->Y:$60451,0,16				//							PC offset 4420
dprHomingPLCVersion->X:$60451,0,16			//							PC offset 4422
dprOverridePLCVersion->Y:$60452,0,16		//							PC offset 4424
dprRunPanelPLCVersion->X:$60452,0,16		//							PC offset 4426
dprMaintenanceVersion->Y:$60453,0,16		//							PC offset 4428
dprToolCarrierVersion->X:$60453,0,16		//							PC offset 4430
dprInitPLCVersion->Y:$60454,0,16			//							PC offset 4432
dprRigidTapVersion->X:$60454,0,16			//							PC offset 4434
dprHandwheelVersion->Y:$60455,0,16			//							PC offset 4436
dprTrakingVersion->X:$60455,0,16			//							PC offset 4438

dprXFeedrate->Y:$60456,0,16					//							PC offset 4440
dprYFeedrate->X:$60456,0,16					//							PC offset 4442
dprZFeedrate->Y:$60457,0,16					//							PC offset 4444

dprFeedrateRunning->X:$60457,0,16			//							PC offset 4446

dprBufferIsOpen->Y:$60458,0,16				//							PC offset 4448
dprLubeLevelLow->X:$60458,0,16				//							PC offset 4450

dprCapturedAngleX->Y:$60459,0,16			//							PC offset 4452
dprCapturedAngleY->X:$60459,0,16			//							PC offset 4454
dprCapturedAngleZ->Y:$6045A,0,16			//							PC offset 4456

dprTimeBasePercentageDRO->X:$6045A,0,16		//							PC offset 4458
dprStatusPLCVersion->Y:$6045B,0,16			//							PC offset 4460

dprNoSpindleAllowed->X:$6045B,0,16			//							PC offset 4462
dprDoorLockState->Y:$6045C,0,16				//							PC offset 4464

dprSpindleWasOnFwd->X:$6045C,0,16			//							PC offset 4466
dprSpindleWasOnRev->Y:$6045D,0,16			//							PC offset 4468

dprToolCarrierIsFront->X:$6045D,0,16		//							PC offset 4470
dprSpindleCurrent->Y:$6045E,0,16			//							PC offset 4472
dprSpindleM502Value->X:$6045E,0,16			//							PC offset 4474
dprUseSoftLimits->Y:$6045F,0,16				//							PC offset 4476
dprRestartRotaryBuffer->X:$6045F,0,16		//							PC offset 4478
dprBinRotBufBusy->Y:$60460,0,16				//							PC offset 4480

dprCapturedPositionX->X:$60460,0,16			//							PC offset 4482
dprCapturedPositionY->Y:$60461,0,16			//							PC offset 4484
dprCapturedPositionZ->X:$60461,0,16			//							PC offset 4486

dprAbortStatus->Y:$60462,0,16				//							PC offset 4488
dprCriticalPLCVersion->X:$60462,0,16		//							PC offset 4490
dprAsciiStrToRotRetVal->Y:$60463,0,16		//							PC offset 4492

dprWashCoolant->X:$60463,0,16				//							PC offset 4494
dprConveyorCW->Y:$60464,0,16				//							PC offset 4496
dprConveyorCCW->X:$60464,0,16				//							PC offset 4498

dprLubePressureError->Y:$60465,0,16			//							PC offset 4500
dprLubePressureLowCount->X:$60465,0,16		//							PC offset 4502

dprDesiredVelocityZero->Y:$60466,0,16		//							PC offset 4504
dprIsDoorUnlocked->X:$60466,0,16			//							PC offset 4506

dprMotor1ActualPos->F:$60467				//							PC offset 4508
dprMotor2ActualPos->F:$60468				//							PC offset 4512
dprMotor3ActualPos->F:$60469				//							PC offset 4516
dprMotor4ActualPos->F:$6046A				//							PC offset 4520
dprMotor5ActualPos->F:$6046B				//							PC offset 4524
dprMotor6ActualPos->F:$6046C				//							PC offset 4528

dprToolCarrierIsBack->Y:$6046D,0,16			//							PC offset 4532
dprAFeedrate->X:$6046D,0,16					//							PC offset 4534

dprCapturedAngle4->Y:$6046E,0,16			//							PC offset 4536
dprCapturedPosition4->X:$6046E,0,16			//							PC offset 4538

dprMotor4CutRadius->F:6046F					//							PC offset 4540
dprMotor4BaseHeight->F:$60470				//							PC offset 4544

dprServoIsFault->Y:$60471,0,16				//							PC offset 4548
// unused ->X:$60471,0,16					//							PC offset 4550

dprZToolOffset->F:$60472					//							PC offset 4552

dprSpindleM505Value->Y:$60473,0,16			//							PC offset 4556
dprMotor4AutoClamp->X:$60473,0,16			//							PC offset 4558

dprHas4thAxis->Y:$60474,0,16				//							PC offset 4560
dprIsResettingServos->X:$60474,0,16			//							PC offset 4562

dprBaseToolHeight->F:$60475					//							PC offset 4564

dprDoorClosedDebounceTime->Y:$60476,0,16	//							PC offset 4568	

dprATCFrontOutput->X:$60476,0,16			//							PC offset 4570
dprATCBackOutput->Y:$60477,0,16			//							PC offset 4572

dprCurrentServoIdxNow->X:$60477,0,16		//							PC offset 4574	
dprCurrentSequenceNum->Y:$60478,0,16		//							PC offset 4576	

dprATCMode->X:$60478,0,16					//							PC offset 4578

dprPrevContinuousMotion->Y:$60479,0,16		//							PC offset 4580

//->X:$60479,0,16				//							PC offset 4582

dprServoIdxNow->DP:$6047A					//							PC offset 4584
dprSequenceNum->DP:$6047B					//							PC offset 4588	

dprGoButtonWasAllowed->Y:$6047C,0,16		//							PC offset 4592
dprCSContMotionRequest->X:$6047C,0,16		//							PC offset 4594

dprStartUpInProgress->Y:$6047D,0,16			//							PC offset 4596	

//->F:$6047E					//							PC offset 4600	
//->F:$6047F					//							PC offset 4604	
//->F:$60480					//							PC offset 4608	

dprMotor9ActualPos->F:$60481				//							PC offset 4612		

dprConveyorWasOn->Y:$60482,0,16				//							PC offset 4616

dprUBufBase->X:$60482,0,16					//							PC offset 4618

dprIs4thAxisUnclamped->Y:$60483,0,16		//							PC offset 4620

dprResetServoPLCVersion->X:$60483,0,16		//							PC offset 4622
dprResetFollowingError->Y:$60484,0,16		//							PC offset 4624
dprToolChangeActive->X:$60484,0,16			//							PC offset 4626
dprMotor9CommandedPos->Y:$60485,0,16		//							PC offset 4628
dprHandwheelEnabled->X:$60485,0,16			//							PC offset 4630

dprErrorLogUpdate->Y:$60486,0,16			//							PC offset 4632
		
dprATCTimingOnToEdge->X:$60486,0,16			//							PC offset 4634	
dprATCTimingEdgeToEdge->Y:$60487,0,16		//							PC offset 4636	
dprATCTimingEdgeToCmdOff->X:$60487,0,16		//							PC offset 4638	
dprATCRotationDirection->Y:$60488,0,16		//							PC offset 4640
dprATCRotationTime->X:$60488,0,16			//							PC offset 4642

dprIsZAxisAtToolChange->Y:$60489,0,16		//							PC offset 4644
dprAAxisType->X:$60489,0,16					//							PC offset 4646
dprLogDPRamData->Y:$6048A,0,16				//							PC offset 4648

dprProductCode->X:$6048A,0,16				//							PC offset 4650

dprTrakSlewRunning->Y:$6048B,0,16			//							PC offset 4652
dprTrakSlewStopped->X:$6048B,0,16			//							PC offset 4654
dprTrakFastAccel->F:$6048C					//							PC offset 4656	
dprTrakSlowAccel->F:$6048D					//							PC offset 4660

dprCurrentFRAXState->DP:$6048E				//							PC offset 4664	

dprCurrentMotionMode->Y:$6048F,0,16			//							PC offset 4668	
dprPreRunMode->X:$6048F,0,16				//							PC offset 4670	

dprHandwheelDirection->Y:$60490,0,16		//							PC offset 4672	

dprFEIndexCounter->X:$60490,0,16			//							PC offset 4674
dprFEAxis->Y:$60491,0,16					//							PC offset 4676
dprFEIndexMin->X:$60491,0,16				//							PC offset 4678
dprFEIndexMax->Y:$60492,0,16				//							PC offset 4680
dprFEIndexDir->X:$60492,0,16				//							PC offset 4682
dprFEAdjustment->Y:$60493,0,16				//							PC offset 4684

dprServosEnabledLatch->X:$60493,0,16			//							PC offset 4686
dprServosEnabled->Y:$60494,0,16				//							PC offset 4688
dprCapturedAxisFlags->X:$60494,0,16			//							PC offset 4690

dprMotor1CurrentFeedback->Y:$60495,0,16		//							PC offset 4692
dprMotor2CurrentFeedback->X:$60495,0,16		//							PC offset 4694
dprMotor3CurrentFeedback->Y:$60496,0,16		//							PC offset 4696
dprMotor4CurrentFeedback->X:$60496,0,16		//							PC offset 4698

dprIsOKToGather->Y:$60497,0,16				//							PC offset 4700

dprRigidTapMode->X:$60497,0,16				//							PC offset 4702

dprSpindleForwardOutput->Y:$60498,0,16		//							PC offset 4704
dprSpindleReverseOutput->X:$60498,0,16		//							PC offset 4706
dprSpindleAgreeInput->Y:$60499,0,16			//							PC offset 4708
dprSpindleOrientOutput->X:$60499,0,16		//							PC offset 4710

dprWatchdogCounter->Y:$6049A,0,16			//							PC offset 4712
dprOKToStop->X:$6049A,0,16					//							PC offset 4714
dprStopButtonPressed->Y:$6049B,0,16			//							PC offset 4716
dprStatThreadExecTime->X:$6049B,0,16		//							PC offset 4718

dprServiceCodeMode->Y:$6049C,0,16			//							PC offset 4720

//->X:$6049C,0,16		//							PC offset 4722

dprTotalATCCount->DP:$6049D					//							PC offset 4724	// this is a long

dprCopyCSVariables->Y:$6049E,0,16			//							PC offset 4728
dprCSContMotion->X:$6049E,0,16				//							PC offset 4730

//->Y:$6049F,0,16			//							PC offset 4732


dprSoftLimitXPos->Y:$604E2,0,16				//							PC offset 5000
dprSoftLimitXNeg->X:$604E2,0,16				//							PC offset 5002
dprSoftLimitYPos->Y:$604E3,0,16				//							PC offset 5004
dprSoftLimitYNeg->X:$604E3,0,16				//							PC offset 5006
dprSoftLimitZPos->Y:$604E4,0,16				//							PC offset 5008
dprSoftLimitZNeg->X:$604E4,0,16				//							PC offset 5010
dprSoftLimit4Pos->Y:$604E5,0,16				//							PC offset 5012
dprSoftLimit4Neg->X:$604E5,0,16				//							PC offset 5014

dprHardLimitXPos->Y:$604E6,0,16				//							PC offset 5016
dprHardLimitXNeg->X:$604E6,0,16				//							PC offset 5018
dprHardLimitYPos->Y:$604E7,0,16				//							PC offset 5020
dprHardLimitYNeg->X:$604E7,0,16				//							PC offset 5022
dprHardLimitZPos->Y:$604E8,0,16				//							PC offset 5024
dprHardLimitZNeg->X:$604E8,0,16				//							PC offset 5026
dprHardLimit4Pos->Y:$604E9,0,16				//							PC offset 5028
dprHardLimit4Neg->X:$604E9,0,16				//							PC offset 5030

dprMaxFollowErrorX->Y:$604EA,0,16			//							PC offset 5032
dprMaxFollowErrorY->X:$604EA,0,16			//							PC offset 5034
dprMaxFollowErrorZ->Y:$604EB,0,16			//							PC offset 5036
dprMaxFollowError4->X:$604EB,0,16			//							PC offset 5038

dprAllLimits->Y:$604EC,0,16					//							PC offset 5040
dprAllFollowError->X:$604EC,0,16			//							PC offset 5042
dprAllFaults->Y:$604ED,0,16					//							PC offset 5044

dprMaxFeedrate->X:$604ED,0,16				//							PC offset 5046
dprGoButtonAllowed->Y:$604EE,0,16			//							PC offset 5048
dprServoAbortFromMaster->X:$604EE,0,16		//							PC offset 5050
dprEnableOverridePLC->Y:$604EF,0,16			//							PC offset 5052
dprTrakingSpeed->X:$604EF,0,16				//							PC offset 5054

dprSpindleRevsTest->F:$604F0				// was $60556				PC offset 5056

RigidTapZRapid->F:$604F1					// was $60557				PC offset 5060
RigidTapDepth->F:$604F2						// was $60558				PC offset 5064
RigidTapStopPosition->F:$604F3				// was $60559				PC offset 5068
RigidTapPitch->F:$604F4						// was $60560				PC offset 5072
RigidTapFeedrate->F:$604F5					// was $60561				PC offset 5076
RigidTapRPM->F:$604F6						// was $60562				PC offset 5080
RigidTapRTIF->F:$604F7						// was $60563				PC offset 5084
RigidTapZBegin->F:$604F8					// was $60564				PC offset 5088

dprTotalMachineTime->F:$604F9				//							PC offset 5092	// this is a float
dprTotalSpindleTime->F:$604FA				//							PC offset 5096	// this is a float
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// $60450 Variable-Sized Buffers & Open-Use Space	- PC offset 4416 - 5118
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


// vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// binary rotary transfer buffer will start at		- PC offset 5120 - 16,378
// DP:$60500
// offset is 176/0xB0 from DP:$60450
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


///////////////////////////
// end of DPRAM allocation
///////////////////////////

// Other Registers
#ifdef PT8
SpindleCmdValue->Y:$07801A,8,16,S			// Spindle Speed Register OUT4A
SpindleEnableAmp->X:$07801D,14				// Amplifier Enable AENA4
#else
SpindleCmdValue->Y:$078102,8,16,S			// Spindle Speed Register OUT5A
SpindleEnableAmp->X:$078105,14				// Amplifier Enable AENA5
#endif

desiredVelocityZeroAxis1->X:$0B0,13,1
desiredVelocityZeroAxis2->X:$130,13,1
desiredVelocityZeroAxis3->X:$1B0,13,1
desiredVelocityZeroAxis4->X:$230,13,1
desiredVelocityZeroAxis5->X:$2B0,13,1
inPositionAxis1->Y:$0C0,0,1
inPositionAxis2->Y:$140,0,1
inPositionAxis3->Y:$1C0,0,1
inPositionAxis4->Y:$240,0,1
inPositionAxis5->Y:$2C0,0,1

Axis1VariableJogPosition->L:$0D7
Axis2VariableJogPosition->L:$157
Axis3VariableJogPosition->L:$1D7
Axis4VariableJogPosition->L:$257
Axis5VariableJogPosition->L:$2D7

CSTimebaseControlAddress->X:$2001,0,16
CSRotaryBufferFull->Y:$203F,16,1

//ElapsedTimeCounter->D:$10F8	// for testing
ElapsedTimeCounter->D:$17

BufferOpenBit->Y:$6,19,1
ContinuousMotionRequestBit->X:$2040,4
CSInPositionBit->Y:$203F,17,1

GlobalStatusFromY->Y:$6,0,24,s
GlobalStatusFromX->X:$6,0,24,s

CSStatusFromX->X:$2040,0,24,s
CSStatusFromY->Y:$2040,0,24,s

CSContinuousMotion->X:$2040,4

#ifdef PT8
Motor1HomeSwitch->X:$78000,16,1
Motor2HomeSwitch->X:$78008,16,1
Motor3HomeSwitch->X:$78010,16,1

SpindleCapturedPosition->X:$7801B,0,24,s
SpindleCapturedFlag->X:$7800C,11
#else
SpindleCapturedPosition->X:$78103,0,24,s
SpindleCapturedFlag->X:$78100,11
#endif

TimeBasePercentageCmd->X:$2000,0,24,s

TimeBaseTrigger->Y:$350B,20,4

#define RedLight 			outAlarmRed
#define YellowLight 		outAlarmYellow
#define GreenLight 			outAlarmGreen
#define AllLightsOn			CMD"M7303..7305=1"
#define AllLightsOff		CMD"M7303..7305=0"


// ******************************************
// Handwheel Jogging and Homing Variables
// ******************************************
// Variables set up according to axis selected

// address of pointers = $4000 + MVar (4501) = $5195
// address of pointers = 16384 + MVar (4501) = 20885
// e.g. ActualPosP = M4571
//      ActualPosM = M4501
//      ActualPosXM = M4511
// finally ActualPosP = ActualPosXM
// use ActualPosP to access the actual position in X
// because of the above set up. To use Z position
// just do ActualPosP = ActualPosZM
ActualPosP->Y:$5195,0,16			// address of M4501
CommandedPosP->Y:5196,0,16			// address of M4502
PosBiasP->Y:$5197,0,16				// address of M4503
JogVarPositionP->Y:$5198,0,16		// address of M4504
DesiredVelZeroP->Y:$5199,0,16		// address of M4505
InPositionP->Y:$519A,0,16			// address of M4506
PosLimitP->Y:$519B,0,16				// address of M4507
NegLimitP->Y:$519C,0,16				// address of M4508
JogVarDistanceP->Y:$519D,0,16		// address of M4509

#define SpindleCurrentBaseQ		$7FAE	// address of P8110
SpindleCurrentBaseP->Y:$51E4,0,16	// address of M4580
SpindleCurrentBaseM->L:SpindleCurrentBaseQ		// address of P8110 in memory

// to use above pointers:ZPosScale
// set M4501->to some address
// then when you want to change the address for M4501
// change M4571 = new address

///////////////////////////////////////////
// X Axis variables
///////////////////////////////////////////

// Jog addresses
#define ActualPosXAddr 			$8B
#define CommandedPosXAddr		$88
#define PosBiasXAddr 			$CC
#define JogVarDistanceXAddr 	$D7
#define ServoSCXAddr 			$B0
#define StatusXAddr 			$C0

ActualPosXM->D:ActualPosXAddr
PosBiasXM->D:PosBiasXAddr
JogVarDistanceXM->L:JogVarDistanceXAddr
DesiredVelZeroXM->X:ServoSCXAddr,13,1
InPositionXM->Y:StatusXAddr,0,1
PosLimitXM->X:ServoSCXAddr,21,1
NegLimitXM->X:ServoSCXAddr,22,1

///////////////////////////////////////////
// Y Axis variables
///////////////////////////////////////////

// Jog addresses
#define ActualPosYAddr 			$10B
#define CommandedPosYAddr		$108
#define PosBiasYAddr 			$14C
#define JogVarDistanceYAddr 	$157
#define ServoSCYAddr 			$130
#define StatusYAddr 			$140

ActualPosYM->D:ActualPosYAddr
PosBiasYM->D:PosBiasYAddr
JogVarDistanceYM->L:JogVarDistanceYAddr
DesiredVelZeroYM->X:ServoSCYAddr,13,1
InPositionYM->Y:StatusYAddr,0,1
PosLimitYM->X:ServoSCYAddr,21,1
NegLimitYM->X:ServoSCYAddr,22,1

///////////////////////////////////////////
// Z Axis variables
///////////////////////////////////////////

// Jog addresses
#define ActualPosZAddr 			$18B
#define CommandedPosZAddr		$188
#define PosBiasZAddr 			$1CC
#define JogVarDistanceZAddr 	$1D7
#define ServoSCZAddr 			$1B0
#define StatusZAddr 			$1C0

ActualPosZM->D:ActualPosZAddr
PosBiasZM->D:PosBiasZAddr
JogVarDistanceZM->L:JogVarDistanceZAddr
DesiredVelZeroZM->X:ServoSCZAddr,13,1
InPositionZM->Y:StatusZAddr,0,1
PosLimitZM->X:ServoSCZAddr,21,1
NegLimitZM->X:ServoSCZAddr,22,1

///////////////////////////////////////////
// 4th Axis variables
///////////////////////////////////////////
// Jog addresses
#define ActualPos4Addr 			$20B
#define CommandedPos4Addr		$208
#define PosBias4Addr 			$24C
#define JogVarDistance4Addr 	$257
#define ServoSC4Addr 			$230
#define Status4Addr 			$240

ActualPos4M->D:ActualPos4Addr
PosBias4M->D:PosBias4Addr
JogVarDistance4M->L:JogVarDistance4Addr
DesiredVelZero4M->X:ServoSC4Addr,13,1
InPosition4M->Y:Status4Addr,0,1
PosLimit4M->X:ServoSC4Addr,21,1
NegLimit4M->X:ServoSC4Addr,22,1

/////////////////////////////////////////// 
// Spindle variables
///////////////////////////////////////////
#ifdef PT8
#define ActualPosSpindleAddr	$20B
ActualPosSpindleM->D:ActualPosSpindleAddr

#define SpindlePosScale		(I408*32)
#else
#define ActualPosSpindleAddr	$28B
ActualPosSpindleM->D:ActualPosSpindleAddr

#define SpindlePosScale		(I508*32)
#endif

///////////////////////////////////////////
// Handwheel variables
///////////////////////////////////////////

//ehwCountM->D:$00020B		// encoder on channel 4
//ehwCountM->D:$00028B		// encoder on channel 5
ehwCountM->D:$00030B			// encoder on channel 6
//ehwCountM->X:$78109,24,S		// encoder on channel 6
#ifdef PT8
ehwDirectionChangedBit->Y:$78418,23,1
ehwTimeBetweenClicks->Y:$78418,0,24
#else
ehwDirectionChangedBit->Y:$78108,23,1
ehwTimeBetweenClicks->Y:$78108,0,24
#endif

///////////////////////////////////////////
// Variables specific to homing
///////////////////////////////////////////

///////////////////////////////////////////
// X Axis variables for Home
///////////////////////////////////////////

// Home addresses for X axis
HomeCompleteXM->Y:StatusXAddr,10,1
PulsePerUnitXM->L:$0000CF

///////////////////////////////////////////
// Y Axis variables for Home
///////////////////////////////////////////

// Home addresses for Y axis
HomeCompleteYM->Y:StatusYAddr,10,1
PulsePerUnitYM->L:$00014F

///////////////////////////////////////////
// Z Axis variables for Home
///////////////////////////////////////////

// Home addresses for Z axis
HomeCompleteZM->Y:StatusZAddr,10,1
PulsePerUnitZM->L:$0001CF

///////////////////////////////////////////
// 4th Axis variables for Home
///////////////////////////////////////////

// Home addresses for 4th axis
HomeComplete4M->Y:Status4Addr,10,1
PulsePerUnit4M->L:$00024f

// used for all timing/delay functions
// this is the system timer
TickCount->X:$0,24
TickCountResult->X:$10FF,24

#endif

// some coordinate system ivars
#define CS1LookaheadState			I5121
#define CS1TimeBaseAddr				I5193
#define CS1TimeBaseSlew				I5194
#define CS1FeedHoldSlew				I5195

#define SlewRateTimeFactor 335551.0	// slew value to go from 0-100% in one second (I5194=SlewRateFactor/TimeInMs)

// different timebase address location
#define CmdTimeBaseAddr				8192			// ($2000) CS commanded time base value	address
#define ManualTimeBaseAddr			4348			// ($10FC) Manual override base address
#define TrakTimeBaseAddr			4349			// ($10FD) Traking time base address

#define VirtualAxisAddr				4347			// ($10FB)

#ifndef __cplusplus

// actual time base value (units of I10)
#define CS1SlewedTimeBaseAddr		$2002			// CS actual slewed time base value address

// all settable timebase controls below
CmdTimeBase->X:CmdTimeBaseAddr,0,24,S				// location of commanded timebase location
ManualTimeBase->X:ManualTimeBaseAddr,0,24,S	// location of unused memory for temporary timebase control
TrakTimeBase->X:TrakTimeBaseAddr,0,24,S				// location of traking timebase location

CS1SlewedTimeBase->X:CS1SlewedTimeBaseAddr,0,24,S	// CS actual slew-limited time base value (units of I10)

CurrentMachineTicks->D:$10F9
CurrentSpindleTicks->D:$10FA
TotalMachineTicks->X:$10FE,24
TotalSpindleTicks->Y:$10FE,24

EndOfMemory->X:$31B2,24

#endif

#endif


